function craftSetup()

    --make entity and scene
    scene = craft.scene()
    scene.sun.rotation=quat.eulerAngles(30,45,30)
    v=scene.camera:add(OrbitViewer, vec3(2.50,0,2.50), 5.65, 0, 1000)
    v.rx=45
    scene.ambientColor = color(196, 186, 163)   
    scene.sky.material.sky = color(235, 171, 72)       
    scene.sky.material.horizon = color(227, 158, 113)       
    scene.sky.material.ground = color(200, 60, 73)   
    entity = scene:entity()    
    entity.model = craft.model()
    
    --set shader and initial variables
    craft.shader.add(undulatingShader)
    local overallSideSize = 5
    entity.material = craft.material("Undulating Shader")   
    
    --function for resetting model based on new square count
    function makeCraftSquares()
        entity.model.positions, entity.model.colors, entity.model.indices = vertsAndColorsBasedOn(squaresPerSide, overallSideSize, true)
        --an attempt that doesn't work:
        setModelDistanceBufferFor(entity.model, squaresPerSide, verticalDistanceIncrement)
    end      
end

--should define, for shader, which square each vertex is a part of
function setModelDistanceBufferFor(model, squaresPerSide, verticalDistanceIncrement)
    --how to add the distances to the entity shader??
    local distancesOfSubSquares = distancesBySquareBelongedTo(squaresPerSide, verticalDistanceIncrement)
    --based on mesh version, doesn't work:
    --[[
    local distanceBuffer = model:buffer("distanceOfSubSquareFromCenter")
    distanceBuffer:resize(#distancesOfSubSquares)
    for i, distance in ipairs(distancesOfSubSquares) do
        distanceBuffer[i] = distance
    end
    ]]
end

undulatingShader = {
    name = "Undulating Shader",
    
    options =
    {
        USE_COLOR = { true },
    },
    
    properties =
    {
        time = {"float", 0.0},
        distanceOfSubSquareFromCenter = {"float", 1.0}
    },
    
    pass =
    {
        base = "Surface",
        vertex =
        [[
        uniform float time;
        uniform float distanceOfSubSquareFromCenter;
        void vertex(inout Vertex v, out Input o)
        {
            float speedMultiplier = 2.5;
            float totalUndulationHeightMultiplier = 0.35;
            float y = sin(distanceOfSubSquareFromCenter + time * speedMultiplier) * totalUndulationHeightMultiplier;
            v.position = vec3(v.position.x, y, v.position.z);
        }
    ]],

surface =
[[
uniform sampler2D map;
uniform vec3 diffuse;

void surface(in Input IN, inout SurfaceOutput o)
{                
    o.emissive = 1.0;                                
    o.emission = vec3(0.0, 0.0, 0.0);
        o.diffuse = IN.color.xyz;
}
]]
}
}