--
-- Demonstration of Undulate with meshes and Craft
--

function setup()
    --setup some basic values
    verticalDistanceIncrement = 20
    squaresPerSide = 20 
    quickTableInsert = table.insert -- cache this function for speed
    
    --setup the squares
    meshSetup()
    craftSetup()
    makeNewSquares()
    
    --setup the parameters
    parametersSetup()
end

function makeNewSquares()
    if craftVersionToggle then
        makeCraftSquares()
    else
        makeMeshSquares()
        cameraFocuser = squaresPerSide / 2 * (math.min(WIDTH, HEIGHT) / squaresPerSide)
    end
end

function parametersSetup()
    parameter.boolean("craftVersionToggle", false, makeNewSquares)
    parameter.boolean("refreshBackground", true)
    parameter.integer("verticalDistanceIncrement", 1, 100, 20, makeNewSquares)
    parameter.integer("squaresPerSide", 1, 100, 20, makeNewSquares)
end

function update(dt)
    scene:update(dt)
end

function draw()
    if refreshBackground then
        background(0)
    end
    perspective() 
    update(DeltaTime)
    if craftVersionToggle then
        entity.material.time = ElapsedTime * 3
        scene:draw()
    else
        if cameraFocuser and meshyMesh then
            camera(cameraFocuser, -200, 1000, cameraFocuser, cameraFocuser, 0, 0, 1, 0)
            meshyMesh.shader.time = ElapsedTime * 3
            meshyMesh:draw()
        end
    end
end
